Attribute VB_Name = "modWIM"
Option Explicit

' The data area passed to a system call is too small.
Const ERROR_INSUFFICIENT_BUFFER As Long = &H7A

' More data is available.
Public Const ERROR_MORE_DATA   As Long = &HEA

' The request was aborted.
Public Const ERROR_REQUEST_ABORTED   As Long = &H4D3

' Indicates an error when calling the WIMRegisterMessageCallback function.
Public Const INVALID_CALLBACK_VALUE   As Long = &HFFFFFFFF

' The .wim file only contains image resources and XML information.
Public Const WIM_ATTRIBUTE_METADATA_ONLY   As Long = &H2

' The .wim file does not have any other attributes set.
Public Const WIM_ATTRIBUTE_NORMAL   As Long = &H0

' The .wim file is locked and cannot be modified.
Public Const WIM_ATTRIBUTE_READONLY   As Long = &H20

' The .wim file only contains file resources and no images or metadata.
Public Const WIM_ATTRIBUTE_RESOURCE_ONLY   As Long = &H1

' The .wim file contains one or more images where symbolic link or junction path fixup is enabled.
Public Const WIM_ATTRIBUTE_RP_FIX   As Long = &H8

' The .wim file has been split into multiple pieces via WIMSplitFile.
Public Const WIM_ATTRIBUTE_SPANNED   As Long = &H10

' The .wim file contains integrity data that can be used by the WIMCopyFile or WIMCreateFile function.
Public Const WIM_ATTRIBUTE_VERIFY_DATA   As Long = &H4

' Adds a new image entry to the .wim file. The default is to update the image specified during mount.
Public Const WIM_COMMIT_FLAG_APPEND   As Long = &H1

' Automatically retries copy operations in event of failures.
Public Const WIM_COPY_FILE_RETRY   As Long = &H1000000

' Makes a new image file. If the file exists, the function overwrites the file.
Public Const WIM_CREATE_ALWAYS   As Long = &H2

' Makes a new image file. If the specified file already exists, the function fails.
Public Const WIM_CREATE_NEW   As Long = &H1

' Removes all mounted images, whether actively mounted or not.
Public Const WIM_DELETE_MOUNTS_ALL   As Long = &H1

' The image will be exported to the destination .wim file even if it is already stored in that .wim file.
Public Const WIM_EXPORT_ALLOW_DUPLICATES   As Long = &H1

' Image resources and XML information are exported to the destination .wim file and no supporting file resources are included.
Public Const WIM_EXPORT_ONLY_METADATA   As Long = &H4

' File resources will be exported to the destination .wim file and no image resources or XML information will be included.
Public Const WIM_EXPORT_ONLY_RESOURCES   As Long = &H2

' Verifies the destination file.
Public Const WIM_EXPORT_VERIFY_DESTINATION   As Long = &H10

' Verifies the source file.
Public Const WIM_EXPORT_VERIFY_SOURCE   As Long = &H8

' Create flag to allow cross-file WIM.
Public Const WIM_FLAG_CHUNKED   As Long = &H20000000

' Sends a WIM_MSG_FILEINFO message during the apply operation.
Public Const WIM_FLAG_FILEINFO   As Long = &H80

' Specifies that the image is to be sequentially read for caching or performance purposes.
Public Const WIM_FLAG_INDEX   As Long = &H4

' Mounts the image using a faster operation.
Public Const WIM_FLAG_MOUNT_FAST   As Long = &H400

' Mounts the image using a legacy operation.
Public Const WIM_FLAG_MOUNT_LEGACY   As Long = &H800

' Mounts the image without the ability to save changes, regardless of WIM access level.
Public Const WIM_FLAG_MOUNT_READONLY   As Long = &H200

' Applies the image without physically creating directories or files. Useful for obtaining a list of files and directories in the image.
Public Const WIM_FLAG_NO_APPLY   As Long = &H8

' Disables restoring security information for directories.
Public Const WIM_FLAG_NO_DIRACL   As Long = &H10

' Disables restoring security information for files
Public Const WIM_FLAG_NO_FILEACL   As Long = &H20

' Disables automatic path fixups for junctions and symbolic links.
Public Const WIM_FLAG_NO_RP_FIX   As Long = &H100

' Reserved for future use.
Public Const WIM_FLAG_RESERVED   As Long = &H1

' Opens the .wim file in a mode that enables simultaneous reading and writing.
Public Const WIM_FLAG_SHARE_WRITE   As Long = &H40

' Verifies that files match original data.
Public Const WIM_FLAG_VERIFY   As Long = &H2

' Specifies mount access to the image file. Enables images to be mounted with WIMMountImageHandle.
Public Const WIM_GENERIC_MOUNT   As Long = &H20000000

' Specifies read-only access to the image file. Enables images to be applied from the file. Combine with WIM_GENERIC_WRITE for read/write (append) access.
Public Const WIM_GENERIC_READ   As Long = &H80000000

' Specifies write access to the image file. Enables images to be captured to the file. Includes WIM_GENERIC_READ access to enable apply and append operations with existing images.
Public Const WIM_GENERIC_WRITE   As Long = &H40000000

' Specifies that the log file should be in UTF8 format.
Public Const WIM_LOGFILE_UTF8   As Long = &H1

' The image mount point is no longer valid.
Public Const WIM_MOUNT_FLAG_INVALID   As Long = &H8

' The mount point has been replaced with by a different mounted image.
Public Const WIM_MOUNT_FLAG_MOUNTDIR_REPLACED   As Long = &H40

' The image is actively mounted.
Public Const WIM_MOUNT_FLAG_MOUNTED   As Long = &H1

' The image is in the process of mounting.
Public Const WIM_MOUNT_FLAG_MOUNTING   As Long = &H2

' The image mount point has been removed or replaced.
Public Const WIM_MOUNT_FLAG_NO_MOUNTDIR   As Long = &H20

' The WIM file backing the mount point is missing or inaccessible.
Public Const WIM_MOUNT_FLAG_NO_WIM   As Long = &H10

' The image has been mounted with read-write access.
Public Const WIM_MOUNT_FLAG_READWRITE   As Long = &H100

' The image is not mounted, but is capable of being remounted.
Public Const WIM_MOUNT_FLAG_REMOUNTABLE   As Long = &H4

' Cancels an image apply or image capture.
Public Const WIM_MSG_ABORT_IMAGE    As Long = &HFFFFFFFF

' Indicates success and prevents other subscribers from processing the message.
Public Const WIM_MSG_DONE           As Long = &HFFFFFFF0

' Indicates the error can be ignored.
Public Const WIM_MSG_SKIP_ERROR     As Long = &HFFFFFFFE

' Indicates success and to enables other subscribers to process the message.
Public Const WIM_MSG_SUCCESS        As Long = &H0

' Opens the image file if it exists. If the file does not exist and the caller requests WIM_GENERIC_WRITE access, the function makes the file.
Public Const WIM_OPEN_ALWAYS        As Long = &H4

' Opens the image file. If the file does not exist, the function fails.
Public Const WIM_OPEN_EXISTING      As Long = &H3

' The specified .wim file is appended to the current list.
Public Const WIM_REFERENCE_APPEND   As Long = &H10000

' The specified .wim file becomes the only item in the list.
Public Const WIM_REFERENCE_REPLACE  As Long = &H20000



Public Const WIM_COMPRESS_NONE As Byte = 0
Public Const WIM_COMPRESS_XPRESS As Byte = 1
Public Const WIM_COMPRESS_LZX As Byte = 2
Public Const WIM_COMPRESS_LZMS As Byte = 3


Public Const WM_APP         As Long = &H8000
Public Const WIM_MSG        As Long = WM_APP + &H1476     '&H9476

Public Const WIM_MSG_TEXT       As Long = 38007
Public Const WIM_MSG_PROGRESS   As Long = 38008   '38008
Public Const WIM_MSG_PROCESS    As Long = 38009
Public Const WIM_MSG_SCANNING   As Long = 38010
Public Const WIM_MSG_SETRANGE   As Long = 38011
Public Const WIM_MSG_SETPOS     As Long = 38012
Public Const WIM_MSG_STEPIT     As Long = 38013
Public Const WIM_MSG_COMPRESS   As Long = 38014
Public Const WIM_MSG_ERROR      As Long = 38015
Public Const WIM_MSG_ALIGNMENT  As Long = 38016
Public Const WIM_MSG_RETRY      As Long = 38017
Public Const WIM_MSG_SPLIT      As Long = 38018
Public Const WIM_MSG_FILEINFO   As Long = 38019
Public Const WIM_MSG_INFO       As Long = 38020
Public Const WIM_MSG_WARNING    As Long = 38021
Public Const WIM_MSG_CHK_PROCESS                As Long = 38022
Public Const WIM_MSG_WARNING_OBJECTID           As Long = 38023
Public Const WIM_MSG_STALE_MOUNT_DIR            As Long = 38024
Public Const WIM_MSG_STALE_MOUNT_FILE           As Long = 38025
Public Const WIM_MSG_MOUNT_CLEANUP_PROGRESS     As Long = 38026
Public Const WIM_MSG_CLEANUP_SCANNING_DRIVE     As Long = 38027
Public Const WIM_MSG_IMAGE_ALREADY_MOUNTED      As Long = 38028
Public Const WIM_MSG_CLEANUP_UNMOUNTING_IMAGE   As Long = 38029
Public Const WIM_MSG_QUERY_ABORT                As Long = 38030
Public Const WIM_MSG_IO_RANGE_START_REQUEST_LOOP As Long = 38031
Public Const WIM_MSG_IO_RANGE_END_REQUEST_LOOP  As Long = 38032
Public Const WIM_MSG_IO_RANGE_REQUEST           As Long = 38033
Public Const WIM_MSG_IO_RANGE_RELEASE           As Long = 38034
Public Const WIM_MSG_VERIFY_PROGRESS            As Long = 38035
Public Const WIM_MSG_COPY_BUFFER                As Long = 38036
Public Const WIM_MSG_METADATA_EXCLUDE           As Long = 38037
Public Const WIM_MSG_GET_APPLY_ROOT             As Long = 38038
Public Const WIM_MSG_MDPAD                      As Long = 38039
Public Const WIM_MSG_STEPNAME                   As Long = 38040
Public Const WIM_MSG_PERFILE_COMPRESS           As Long = 38041
Public Const WIM_MSG_CHECK_CI_EA_PREREQUISITE_NOT_MET As Long = 38042
Public Const WIM_MSG_JOURNALING_ENABLED         As Long = 38043



Public Declare Function WIMCloseHandle Lib "WIMGAPI.DLL" (ByVal hObject As Long) As Boolean

Public Declare Function WIMCreateFile Lib "WIMGAPI.DLL" ( _
    ByVal lpszWimPath As Long, _
    ByVal dwDesiredAccess As Long, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal dwCompressionType As Long, _
    ByRef CreationResult As Long) As Long
   
Public Declare Function WIMGetImageInformation Lib "WIMGAPI.DLL" ( _
    ByVal hImage As Long, _
    ByRef ppvImageInfo As Long, _
    ByRef pcbImageInfo As Long) As Long

Public Declare Function WIMSetTemporaryPath Lib "WIMGAPI.DLL" ( _
    ByVal hWim As Long, _
    ByVal lpszPath As Long) As Boolean

Public Declare Function WIMLoadImage Lib "WIMGAPI.DLL" ( _
    ByVal hWim As Long, _
    ByVal dwImageIndex As Long) As Long

Public Declare Function WIMApplyImage Lib "WIMGAPI.DLL" ( _
    ByVal hImage As Long, _
    ByVal lpszPath As Long, _
    ByVal dzApplyFlags As Long) As Boolean

Public Declare Function WIMRegisterMessageCallback Lib "WIMGAPI.DLL" ( _
    ByVal hWim As Long, _
    ByVal fpMessageProc As Long, _
    ByVal pvUserData As Long) As Long
   
Public Declare Function WIMUnregisterMessageCallback Lib "WIMGAPI.DLL" ( _
    ByVal hWim As Long, _
    ByVal fpMessageProc As Long) As Boolean



    Public hWim As Long
    Public hImage As Long
    Public AplyCancel As Boolean
    'Public bIsInIDE    As Boolean
    Public nTime As Long


    'Public bIsInIDE    As Boolean
    Public m_pfnPrevCallback       As Long             ' // Previous callback function


'Public Sub TestWIMGAPI2()
'    Dim wimFilePath As String
'    wimFilePath = "r:\WinXP2012.wim"
'
'    Dim wimFileTMPPath As String
'    wimFileTMPPath = "r:\tmp\"
'
'    Dim strApplyPath As String
'    strApplyPath = "r:\"
'
'
'    Dim status As Boolean
'    Dim MyStr As String
'    Dim LInfo As Long
'    Dim PInfo As Long
'    Dim retCreate As Long
'    Dim nRet As Long
'
'
'    hWim = WIMCreateFile( _
'        ByVal StrPtr(wimFilePath), _
'        WIM_GENERIC_READ, _
'        WIM_OPEN_EXISTING, _
'        0, _
'        WIM_COMPRESS_NONE, _
'        ByVal VarPtr(retCreate))
'
'
'    nRet = 0
'    nRet = WIMGetImageInformation(ByVal hWim, ByVal VarPtr(PInfo), ByVal VarPtr(LInfo))
'    Debug.Print "WIMGetImageInformation: " & nRet
'
'    nRet = 0
'    nRet = WIMSetTemporaryPath(hWim, ByVal StrPtr(wimFileTMPPath))
'    Debug.Print "WIMSetTemporaryPath: " & nRet
'
'    hImage = WIMLoadImage(hWim, 1)
'
'
'
'
'   Dim bIsInIDE As Boolean
'    ' // Setup callback
'    If bIsInIDE Then
'        m_pfnPrevCallback = WIMRegisterMessageCallback(hWim, InitCurrentThreadAndCallFunctionIDEProc( _
'                                                                    AddressOf WIMMessageCallback, 16), 0)
'    Else
'        m_pfnPrevCallback = WIMRegisterMessageCallback(hWim, AddressOf WIMMessageCallbackEXE, 0)
'    End If
'
'    Debug.Print "RegisterMessageCallback: " & m_pfnPrevCallback
'
'
'    'nRet = 0
'    'nRet = WIMRegisterMessageCallback(hWim, AddressOf WIMMessageCallback, 0)
'
'
'
'
'
'
'    AplyCancel = False
'
'    Dim nFlag As Long
'    nFlag = 0
'
'   nFlag = WIM_FLAG_VERIFY Or WIM_FLAG_NO_RP_FIX
'
'
'   Debug.Print "ApplyImage: " & WIMApplyImage(hImage, ByVal StrPtr(strApplyPath), nFlag)
''StrFromUniPtr (Err.LastDllError)
'
'
'    nRet = 0
'    nRet = WIMUnregisterMessageCallback(hWim, AddressOf WIMMessageCallback)
'    Debug.Print "WIMUnregisterMessageCallback: " & nRet
'
'    WIMCloseHandle (hImage)
'    WIMCloseHandle (hWim)
'End Sub
'

